<template>
  <div>
    <el-row>
      <!--查询-->
      <el-col :span="24">
        <Form
          inline
          onsubmit="return false"
          :label-width="70"
          v-show="searchOpen">
          <label class="label-sign"></label>
          <Form-item class="search-item" label="地区编码:">
            <el-input v-model="formObj.code" placeholder="请输入编码" @keyup.enter.native="_formSearch" clearable></el-input>
          </Form-item>
          <Form-item class="search-item" label="中文名:">
            <el-input v-model="formObj.cn" placeholder="请输入中文名" @keyup.enter.native="_formSearch" clearable></el-input>
          </Form-item>
          <Form-item class="search-item" label="城市编码:">
            <cityCode style="width: 100%;" @on-result-change="_selectCity" />
            <input v-model="formObj.cityCode" type="hidden" />
          </Form-item>
          <Form-item class="search-btn">
            <el-button type="primary" @click="_formSearch">搜索</el-button>
          </Form-item>
        </Form>
      </el-col>
      <!--按钮-->
      <el-col :span="24">
        <btn-list :msg="btn" :open="searchOpen" @on-result-change="_btnClick" showSearchBtn="true"/>
      </el-col>
      <!--table-->
      <el-col :span="24">
        <element-table
          :pageColumns="pageColumns"
          :tableHeight="tableHeight"
          @on-result-change="_tableResultChange"
          ref="pageTable"
          :getPage="getPage"
          :optColWidth="80"
          :iconMsg="iconMsg">
          <el-table-column
            show-overflow-tooltip
            sortable
            :prop="item.key"
            :label="item.title"
            :min-width="item.width"
            :fixed="item.fixed?item.fixed:undefined"
            v-for="item in pageColumns"
            :key="item.key">
            <template slot-scope="scope">
              <div>{{scope.row[item.key]}}</div>
            </template>
          </el-table-column>
        </element-table>
      </el-col>
    </el-row>
    <!--添加编辑-->
    <sysAreaEdit ref="editModal" @on-result-change="_page"></sysAreaEdit>
  </div>
</template>
<script>
import { sysArea } from '../../../api'
import cityCode from '../../../components/base/cityCode'
import sysAreaEdit from './sysAreaEdit'
export default {
  components: {
    sysAreaEdit,
    cityCode
  },
  data() {
    return {
      searchOpen: true,
      formObj: {
        code: '',
        cn: '',
        cityCode: ''
      },
      btn: [{ type: 'success', id: 'sys-area-add', name: '添加' }],
      pageColumns: [
        { title: '地区编码', key: 'code' },
        { title: '中文名', key: 'cn' },
        { title: '英文名', key: 'en' },
        { title: '城市编码', key: 'cityCode' }
      ],
      getPage: {},
      iconMsg: [{ type: 'pt-edit', id: 'sys-area-edit', name: '编辑' }]
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('search')
      } else {
        return this.$tableHeight('noSearch')
      }
    }
  },
  mounted() {
    this._formSearch()
  },
  methods: {
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    _page: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      const result = await sysArea.page(this.$serializeForm(this.formObj))
      if (result) {
        this.getPage = result
        this.$refs.pageTable._initTable()
      }
    },
    _btnClick(msg, data) {
      switch (msg) {
        case '添加':
          this.$refs.editModal._open()
          break
        case 'search':
          this.searchOpen = !this.searchOpen
          break
      }
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'page':
          this._page()
          break
        case 'iconClick':
          this._iconClick(data.name, data.rowData)
          break
      }
    },
    _iconClick(res, data) {
      switch (res) {
        case '编辑':
          this._editModal(data.id)
          break
      }
    },
    _editModal: async function(id) {
      const result = await sysArea.getById(id)
      this.$refs.editModal._open(result)
    },
    _selectCity(data) {
      this.formObj.cityCode = data
    }
  }
}
</script>
